<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;
use Carbon\Carbon;
use App\Http\Providers\iam\core\model\OracleOCIConnector;

class StgpelniscmmoiintModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "stg_pelni_scm_moi_int";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "stgpelniscmmoiint";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * check the incrementing boolean if the incrementing from database is false then the value is false by default
     */
    // public $incrementing = false;
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "transaction_number",
        "organization_id",
        "subinventory_code",
        "inventory_item_id",
        "item_segment1",
        "transaction_quantity",
        "transaction_date",
        "source_code",
        "process_flag",
        "transaction_mode",
        "lock_flag",
        "transaction_source_type_id",
        "transaction_action_id",
        "attribute2",
        "attribute14",
        "flagsync",
        "voyage_call",
        "total_line"

    ];

    public static function prepareSaveToOracle()
    {
        $start = 0;
        $limit = 100;
        $nRepeat = 0;
        (new LogsyncoracleModel)->setLogSync("Penggunaan Barang", Carbon::now()->toDateTimeString(), "", "start");
        do {
            $stagings = (new StgpelniscmmoiintModel())->getQuery()
                ->whereNull("stgpelniscmmoiint.flagsync")
                ->orWhere("stgpelniscmmoiint.flagsync", "<", 1)
                ->offset($start)->limit($limit)->get();
            foreach ($stagings as $stag) {
                if ((new StgpelniscmmoiintModel())->saveToOracle($stag)) {
                    $updateStg = self::find($stag->id);
                    $updateStg->flagsync = 1;
                    $updateStg->update();
                }
            }
            if (count($stagings) < $limit) {
                $repeat = false;
            } else {
                $repeat = true;
                $start += $limit;
            }
            if (count($stagings) > 0) {
                $nRepeat++;
            }
        } while ($repeat);
        if ($nRepeat > 0) {
            (new LogsyncoracleModel)->setLogSync("Penggunaan Barang", Carbon::now()->toDateTimeString(), "", "success");
        }
    }


    public function saveToOracle($data)
    {
        $query = "INSERT INTO pelni_scm_moi_int (TRANSACTION_NUMBER,ORGANIZATION_ID,SUBINVENTORY_CODE,INVENTORY_ITEM_ID,ITEM_SEGMENT1,TRANSACTION_QUANTITY,
TRANSACTION_DATE,SOURCE_CODE,PROCESS_FLAG,TRANSACTION_MODE,LOCK_FLAG,TRANSACTION_SOURCE_TYPE_ID,TRANSACTION_ACTION_ID, ATTRIBUTE2, VOYAGE_CALL, TOTAL_LINE, ATTRIBUTE14) 
VALUES (
'" . $data->transaction_number . "','" . $data->organization_id . "','" . $data->subinventory_code . "',
'" . $data->inventory_item_id . "','" . $data->item_segment1 . "','" . $data->transaction_quantity . "',TO_DATE('" . Carbon::parse($data->transaction_date)->format("Y/m/d H:i:s") . "', 'yyyy/mm/dd hh24:mi:ss'),
'" . $data->source_code . "','" . $data->process_flag . "','" . $data->transaction_mode . "','" . $data->lock_flag . "','" . $data->transaction_source_type_id . "','" . $data->transaction_action_id . "',
'" . $data->attribute2 . "', '" . $data->voyage_call . "', '" . $data->total_line . "', '" . $data->attribute14 . "')";
        try {
            $oracleOCI = new OracleOCIConnector();
            $oracleOCI->getConnection()->insert($query)->execute();
            (new LogsyncoracleModel)->setLogSync("Penggunaan Barang : ".$data->transaction_number." - ".$data->item_segment1." - ".$data->source_code, Carbon::now()->toDateTimeString(), "", "posted");
            $oracleOCI->closeConnection();
            return true;
        } catch (\Exception $e) {
            (new LogsyncoracleModel)->setLogSync("Penggunaan Barang : ".$data->transaction_number." - ".$data->item_segment1." - ".$data->source_code, Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
            return false;
        }
    }
}